<?php
if ( ! defined( 'ABSPATH' ) ) exit;
// ------------------------------------------------------------------------
// shortcode to display membership levels, perks, and prices
// ------------------------------------------------------------------------
function cdashmm_membership_levels_shortcode( $atts ) {
	// Attributes
	extract( shortcode_atts(
		array(
			'orderby' => 'priority', // options: name, count, priority
			'exclude' => '',
			'order' => 'ASC'
		), $atts )
	);
	// get all of the membership levels
	if( $orderby == 'priority' ) {
		$args = 'orderby=term_order&order='.$order.'&hide_empty=0';
	} elseif( $orderby == 'name' ) {
		$args = 'orderby=name&order='.$order.'&hide_empty=0';
	}
	elseif( $orderby == 'count' ) {
		$args = 'orderby=count&order='.$order.'&hide_empty=0';
	} else {
		$args = 'hide_empty=0';
	}
	if( '' !== 'exclude' ) {
		$args .= '&exclude=' . $exclude;
	}
	$levels = get_terms( 'membership_level', $args );
	$levels_view = '<div id="membership-levels">';
	// go through each level and display the information
	foreach( $levels as $level ) {
		$levelid = $level->term_id;
		$price = cdashmm_get_membership_level_price($levelid);
		$price_term = cdashmm_price_term();
		$levels_view .= '<div class="level">';
		$levels_view .= '<h3>' . $level->name . '</h3>';
		$levels_view .= do_shortcode( stripslashes( wpautop( get_tax_meta( $level->term_id,'perks' ) ) ) );
		$levels_view .= '<p class="price">' . cdashmm_display_price( $price ) . __(' <span class="price_term">'. $price_term .'</span>', 'cdashmm' ) . '</p>';
		$levels_view .= '</div>';
	}
	$levels_view .= '</div>';
	return $levels_view;
}
add_shortcode( 'membership_levels', 'cdashmm_membership_levels_shortcode' );
// ------------------------------------------------------------------------
// shortcode to display membership sign-up/renewal form
// ------------------------------------------------------------------------
function cdashmm_membership_signup_form($atts) {
	global $woocommerce;
	// Attributes
	extract( shortcode_atts(
		array(
			'action' => 'signup', // options: signup, renewal
		), $atts )
	);
	// Enqueue stylesheet
	wp_enqueue_style( 'cdashmm-membership', plugin_dir_url(__FILE__) . 'css/cdashmm-membership.css' );
	// Enqueue ajax to make the form work
	wp_enqueue_script( 'html5validate', plugin_dir_url(__FILE__) . 'js/jquery.h5validate.js', array( 'jquery' ) );
	wp_enqueue_script( 'membership-form', plugin_dir_url(__FILE__) . 'js/membership.js', array( 'jquery' ));
  wp_localize_script( 'membership-form', 'membershipformajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
	$options = get_option( 'cdashmm_options' );
	$paypal = true;
	if( (!isset( $options['paypal_email'] )) || ('' == $options['paypal_email']) ) {
  	$paypal = false;
  }
  $cdash_options = get_option( 'cdash_directory_options' );
  $currency = $cdash_options['currency'];
	global $member_form;
	$member_form = '';

	// Display form
	if( !isset( $currency ) ) {
		$member_form .= __( 'You have not entered in your currency settings.  In your WordPress dashboard, go to the Chamber Dashboard settings page to select what currency you accept.', 'cdashmm' );
	} else {
		$member_form .=
		//'<form id="membership_form" name="membership_form" action="https://ipnpb.paypal.com/cgi-bin/webscr" method="post">
		'<form id="membership_form" name="membership_form" action="https://www.paypal.com/cgi-bin/webscr" method="post">
			<p class="explain">' . __( '* = Required') . '</p>
			<input name="cdashmm_membership_nonce" id="cdashmm_membership_nonce" type="hidden" value="' . wp_create_nonce( 'cdashmm_membership_nonce' ) . '">';
			$member_form .= '<fieldset>
			<legend>Business Details</legend>';
			$member_form .= cdashmm_membership_form_biz_name($action);
			$member_form .= cdashmm_membership_form_biz_category($action);
			$member_form .= cdashmm_membership_form_biz_billing();
			$member_form .= cdashmm_membership_form_biz_contact();
			$member_form .= cdashmm_membership_form_biz_main_address($action);
			$member_form .= cdashmm_display_referral_dropdown($action);
			$member_form .= '</fieldset>';
			//if( (cdash_check_cdashmu_active()) || ( cdashmm_check_mm_connected_to_wc() ) || ( cdashmm_check_mm_connected_to_wc_payments() ) ) {
			if(cdashmm_show_user_registration()){
				$member_form .= cdashmm_membership_form_user_fields($action);
			}
			$member_form .= '<fieldset>
				<legend>Select Membership Level and Pay</legend>
			';
			$member_form .= cdashmm_membership_form_biz_membership_level();
			$member_form .= cdashmm_membership_form_totals();

			//Check if MM Pro is active, WooCommerce is active and MM is connected to WC
			if(cdashmm_check_mm_connected_to_wc() || cdashmm_check_mm_connected_to_wc_payments()){
				$member_form .= cdashmm_wc_payments_method();
				//$member_form .= cdashmm_membership_form_submit_button();
			}else{
				//Display Payment methods and hidden PayPal fields since WC Payments is not active
				$member_form .= cdashmm_membership_form_paypal_fields($paypal);
				//$member_form .= cdashmm_membership_form_submit_button();
			}
			$member_form .= cdashmm_display_terms_cond();
			$member_form .= cdashmm_display_consent_box();
			$member_form .= cdashmm_mailchimp_subscribe_field($action);
			$member_form .= cdashmm_membership_form_submit_button($action);
			$member_form .= '
			</fieldset>
		</form>';
	}
	return $member_form;
}
add_shortcode( 'membership_form', 'cdashmm_membership_signup_form' );


function cdashmm_membership_form_biz_name($action){
	if(!isset($member_form)){
		$member_form = '';
	}
	$member_form .= '
	<p>
		<label>' . __( 'Business Name', 'cdashmm' ) . ' *</label>
		<input name="name" class="' . $action . '" type="text" id="name" required>
		<input type="hidden" name="cdashmm_form_action" id="cdashmm_form_action" value = "' . $action . '" />
	</p>';
	if($action == 'renewal'){
		$member_form .= '<div id="business-picker"></div>
		<input name="business_id" type="hidden" id="business_id" value="">';
	}
	return $member_form;
}

function cdashmm_membership_form_biz_category($action){
	if(!isset($member_form)){
		$member_form = '';
	}
	if($action == 'signup'){
		$terms = get_terms( array(
				'taxonomy' => 'business_category',
				'hide_empty' => false,
		) );
		$member_form .=
		'<p>
			<label>' . __( 'Business Category', 'cdashmm' ) . ' *</label>
			<select name="business_category" id="business_category" required>
			<option value="">Select One</option>';
			foreach($terms as $single_category){
				$category_id = $single_category->term_id;
				$category_slug = $single_category->slug;
				$category_name = $single_category->name;
				$member_form .= '<option value ="' . $category_id . '">'. $category_name .'</option>';
			}
			$member_form .= '
			</select>
		</p>';
	}
	return $member_form;
}

function cdashmm_membership_form_biz_billing(){
	if(!isset($member_form)){
		$member_form = '';
	}
	$member_form .=
	'<p>
		<label>' . __( 'Billing Address', 'cdashmm' ) . ' *</label>
		<input name="address" type="text" id="address" required>
	</p>
	<p>
		<label>' . __( 'City', 'cdashmm' ) . ' *</label>
		<input name="city" type="text" id="city" required>
	</p>
	<p>
		<label>' . __( 'State/Province', 'cdashmm' ) . ' *</label>
		<input name="state" type="text" id="state" required>
	</p>
	<p>
		<label>' . __( 'Zip/Postal Code', 'cdashmm' ) . ' *</label>
		<input name="zip" type="text" id="zip" required>
	</p>
	<p>
		<label>' . __( 'Country', 'cdashmm' ) . ' *</label>';
		if(cdashmm_check_mm_connected_to_wc()){
			$member_form .= cdashmm_pro_countries_dropdown();
		}else{
			$member_form .= '<input name="country" type="text" id="country" required>';
		}

	$member_form .= '</p>';
	return $member_form;
}

function cdashmm_membership_form_biz_contact(){
	if(!isset($member_form)){
		$member_form = '';
	}
	$member_form .= '<p>
		<label>' . __( 'Email', 'cdashmm' ) . ' *</label>
		<input name="email" type="email" id="email" required>
		<span id="email_error"></span>
	</p>
	<p>
		<label>' . __( 'Phone Number', 'cdashmm' ) . ' *</label>
		<input name="phone" type="text" id="phone" required>
	</p>';
	return $member_form;
}

function cdashmm_membership_form_biz_main_address($action){
	if(!isset($member_form)){
		$member_form = '';
	}
	if($action == 'signup'){
		$member_form .= '<p>
		<input type="checkbox" name="biz_main_address" id="biz_main_address" checked="checked" /> <label  class="label_right">' .__('Use this billing address as my business address.', 'cdashmm') . '</label>';
	}
	return $member_form;
}

function cdashmm_membership_form_biz_membership_level(){
	if(!isset($member_form)){
		$member_form = '';
	}
	$member_form .= '<p>
		<label>' . __( 'Membership Level', 'cdashmm' ) . ' *</label>';
		$args = 'orderby=term_order&order=ASC&hide_empty=0';
		$levels = get_terms( 'membership_level', $args );
		$predetermined_level = false;
		if( isset( $_GET['membership_level'] ) ) {
			// we have a membership level parameter, so first let's make sure it matches an existing membership level
			$level_slugs = array();
			foreach( $levels as $level ) {
				$levelid = $level->term_id;
				$level_slugs[] = $level->slug;
			}
			if( in_array( $_GET['membership_level'], $level_slugs ) ) {
				$predetermined_level = true;
			}
		}
		if( true == $predetermined_level ) {
			$levelid = $this_level->term_id;
			$this_level = get_term_by( 'slug', $_GET['membership_level'], 'membership_level' );
			//$levelid = $this_level->term_id;
			$price = cdashmm_display_price( cdashmm_get_membership_level_price($levelid) );
			$member_form .= '<input class="' .$levelid .'" name="level" type="text" id="level" disabled value="' . $this_level->name . ' - ' . $price . '">';
			$starting_price = cdashmm_get_membership_level_price($levelid);
		} else {
			$member_form .= '<select name="level" id="level" required>
				<option value=""></option>';
				// get all the levels
				foreach( $levels as $level ) {
					$levelid = $level->term_id;
					$price = cdashmm_display_price( cdashmm_get_membership_level_price($levelid) );
					// display the membership level name and price
					$member_form .= '<option value="' . $level->term_id . '">' . $level->name . ':&nbsp' . $price . '</option>';
				}
			$member_form .= '</select></p>';
			$member_form .= '<input type="hidden" value="" name="membership_amt" id="membership_amt">';
			$starting_price = 0;
		}
		return $member_form;
}

function cdashmm_membership_form_totals(){
	if(!isset($starting_price)){
		$starting_price = 0;
	}
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');
	//$member_form .= '<input type="hidden" value="" name="membership_amt" id="membership_amt">';
	if( isset( $options['use_processing_fee'] ) ) {
		if( isset( $options['processing_fee_amount'] ) ) {
			$fee = $options['processing_fee_amount'];
		} else {
			$fee = 0;
		}
		//if( isset( $options['use_processing_fee'] ) ) {
			$member_form .= '<p>
				<label>' . __( 'Processing Fee', 'cdashmm' ) . '</label>
				<input disabled name="processing" type="number" min="0" id="processing" value="' . $fee . '">';
			$member_form .= '</p>';
		//}
		$starting_price += $fee;
	}
	$member_form .= '
	<input name="subtotal" type="hidden" id="subtotal" value="' . $starting_price . '">';
	if( !isset($options['no_donation']) || $options['no_donation'] == 0 ) {
		$member_form .= '<p>
			<label>' . __( 'Optional Donation', 'cdashmm' ) . '</label>
			<input name="donation" type="number" min="0" id="donation" value="' . $options['suggested_donation'] . '">';
			$starting_price += $options['suggested_donation'];
			if( isset( $options['donation_explanation'] ) ) {
				$member_form .= '<br /><span class="donation_explanation">' . $options['donation_explanation'] . '</span>';
			}
		$member_form .= '</p>';
	}

	if( isset( $options['charge_tax'] ) && $options['charge_tax'] == 1 ) {
		if( isset( $options['tax_rate'] ) && (!is_null($options['tax_rate']) ) ) {
			$tax = round( ( ( $options['tax_rate'] / 100 ) * $starting_price ), 2 );
		} else {
			$tax = 0;
		}
		$member_form .= '<p>
					<label>' . __( 'Tax', 'cdashmm' ) . '</label>
					<input type="hidden" name="tax-rate" id="tax-rate" value="' . $options['tax_rate'] . '">
					<input disabled name="tax" type="number" step=".01" min="0" id="tax" value="' . $tax . '">';
		$member_form .= '</p>';
		$starting_price += $tax;
	}
	$member_form .= '
	<p class="total">
		<label>' . __( 'Total Due: ', 'cdashmm' ) . '</label>
		<input name="total" id="total" class="total" value="' . $starting_price . '" disabled>
	</p>';
	return $member_form;
}

function cdashmm_membership_form_submit_button($action){
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');
	if($action == 'renewal'){
		$submit_button_label = 'Renew';
	}else{
		if((isset($options['submit_button_label'])) && ($options['submit_button_label'] != '') ){
			$submit_button_label = $options['submit_button_label'];
		}else{
			$submit_button_label = 'Join Now';
		}
	}
	$member_form .= '<p>
		<input type="submit" value="' . $submit_button_label . '">
	</p>';
	$member_form .= '<p><input type="hidden" value="'. $action . '"></p>';
	return $member_form;
}

function cdashmm_wc_payments_method(){
	if(!isset($member_form)){
		$member_form = '';
	}
	$member_form .= '<p class="method" style="display: none;">
		<label>' . __( 'Payment Method: ', 'cdashmm' ) . '</label>
		<input name="method" type="radio" value="wc_payments" id="pay_wc_payments" class="method" checked>&nbsp;' . __( 'WC Payments', 'cdashmm' ) . '
	</p>';
	do_action( 'cdashmm_recurring_invoice_message', $member_form );
	return $member_form;
}

function cdashmm_membership_form_paypal_fields($paypal){
	$cdash_options = get_option( 'cdash_directory_options' );
	$currency = $cdash_options['currency'];
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');
	if( true == $paypal ) {
		$member_form .= '<p class="method">
			<label>' . __( 'Payment Method: ', 'cdashmm' ) . '</label>
			<input name="method" type="radio" value="paypal" id="pay_paypal" class="method" checked>&nbsp;' . __( 'PayPal', 'cdashmm' ) . '<br />
			<input name="method" type="radio" value="check" id="pay_check" class="method">&nbsp;' . __( 'Check', 'cdashmm' ) . '
		</p>';
		do_action( 'cdashmm_recurring_payments_fields', $member_form );
	} else {
		$member_form .= '<p class="method" style="display: none;">
			<label>' . __( 'Payment Method: ', 'cdashmm' ) . '</label>
			<input name="method" type="radio" value="check" id="pay_check" class="method" checked>&nbsp;' . __( 'Check', 'cdashmm' ) . '
		</p>';
	}
	$member_form .= '<div class="hidden-paypal-fields">';
	if(function_exists('cdashrp_requires_wordpress_version')){
		if(function_exists('cdashrp_default_payment_option')){
			$payment_option = cdashrp_default_payment_option();
				//remove_action( 'cdashmm_paypal_hidden_fields', 'cdashmm_paypal_cart_fields', 10 );
				cdashrp_paypal_fields($payment_option);
		}else{
			remove_action( 'cdashmm_paypal_hidden_fields', 'cdashmm_paypal_cart_fields', 10 );
		}
	}
	do_action( 'cdashmm_paypal_hidden_fields', $member_form );
	if((isset($options['paypal_return_url'])) && !empty($options['paypal_return_url']) ){
			$paypal_return_url = $options['paypal_return_url'];
	}else{
		$paypal_return_url = get_permalink();
	}


	$member_form .=
	'<input type="hidden" class="paypal business" name="business" value="' . $options['paypal_email'] . '">
	<input type="hidden" class="paypal return" name="return" value="' . $paypal_return_url . '">
	<input type="hidden" class="paypal currency_code" name="currency_code" value="' . $currency . '">
	<input type="hidden" class="paypal rm" name="rm" value="2">
	<input type="hidden" class="paypal no_shipping" name="no_shipping" value="1">
	<input type="hidden" class="paypal custom" name="custom" id="invoice_id" value="' . cdashmm_calculate_invoice_number() . '">
	<input type="hidden" class="paypal cbt" name="cbt" value="Return to ' . $options['orgname'] . '">
	<input type="hidden" class="paypal notify_url" name="notify_url" value="' . home_url() . '/?cdash-member-manager=paypal-ipn">
	</div>';
	return $member_form;
}

function cdashmm_display_consent_box(){
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');
	if(isset($options['show_consent_box']) && $options['show_consent_box'] == 1){
		if(($options['consent_box_text'] != '')) {
			//$member_form .= '<p class="cdashmm_terms_statement">'. $options['terms_statement'] . '</p>';
			$member_form .= "<p><input id='cdashmm_frontend_consent_box' class='cdashmm_frontend_consent_box' type='checkbox' name='cdashmm_frontend_consent_box' required /> ";
			$member_form .= "<label class='label_right'>" . $options['consent_box_text'] . "</label></p>";
		}
	}
	return $member_form;
}

function cdashmm_display_terms_cond(){
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');
	if( ($options['terms_statement'] != '') ){
		$member_form .= '<p class="cdashmm_terms_statement">'. $options['terms_statement'] . '</p>';
	}
	return $member_form;
}

function cdashmm_display_referral_dropdown($action){
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');

	//$referral_list = $options['referral_dropdown_list'];
	if($action == "signup"){
		if(isset($options['show_referral_dropdown']) && $options['show_referral_dropdown'] == 1){
			if($options['referral_dropdown_list'] != ''){
				$referral_list = $options['referral_dropdown_list'];
				$referral_list_items = explode("\n", $referral_list);
				$member_form .= "<p>How did you hear about us?</p>";
				$member_form .= "<select name='referral_dropdown' id='referral_dropdown'>";
				$member_form .= "<option name='select_one'>Please select an option</option>";
				foreach ( $referral_list_items as $referral_list_item ) {
					$member_form .= "<option name='" . trim($referral_list_item) . "'>" . trim($referral_list_item) . "</option>";
				}
				$member_form .= "</select>";
			}
		}
	}
	return $member_form;
}

function cdashmm_membership_form_user_fields($action){
	//do this only if it is the sign up form
	if(!isset($member_form)){
		$member_form = '';
	}
	if($action == 'signup'){

			$member_form .= '<fieldset>
				<legend>User Registration</legend>
			<p>
				<label>' . __( 'First Name', 'cdashmm' ) . ' *</label>
				<input name="first_name" type="text" id="first_name" required>
			</p>
			<p>
				<label>' . __( 'Last Name', 'cdashmm' ) . ' *</label>
				<input name="last_name" type="text" id="last_name" required>
			</p>
			<p>
				<label>' . __( 'User Name', 'cdashmm' ) . ' *</label>
				<input name="username" type="text" id="username" required>
				<span id="username_error"></span>
			</p>
			<p>
				<label>' . __( 'Password', 'cdashmm' ) . ' *</label>
				<input name="password" type="password" id="password" required>
				<span id="password_error"></span>
			</p>
			</fieldset>';
	}
	else{
		$member_form .= '';
	}
	return $member_form;
}

//Display subscribe checkbox if MailChimp addon is active
function cdashmm_mailchimp_subscribe_field($action){
	if(!isset($member_form)){
		$member_form = '';
	}
	$options = get_option('cdashmm_options');

	if($action == 'signup'){
		if(cdashmm_check_mailchimp_addon()){
			$cdashmc_options = get_option('cdash_addon_options');
			$list = $cdashmc_options['cdashmc_list'];
			$message = $cdashmc_options['cdashmc_custom_newsletter_message'];
			if($cdashmc_options['cdash_mailchimp_api_key'] != '' && $list != ''){
					//$member_form .= "The subscribe box goes here.";
					$member_form .= cdashmc_subscribe_checkbox($list, $message);
					//$member_form .= $list;
			}
		}
	}
	return $member_form;
}
// ------------------------------------------------------------------------
// Display PayPal hidden fields
// ------------------------------------------------------------------------

function cdashmm_paypal_cart_fields() {
	if(!isset($starting_price)){
		$starting_price = 0;
	}
	global $member_form;
	$options = get_option( 'cdashmm_options' );
    //$fee = 0;
    if(isset($options['use_processing_fee']) ){
        if(isset($options['processing_fee_amount']) ){
            $fee = $options['processing_fee_amount'];
        }
        else{
            $fee = 0;
        }
    }
    else{
        $fee = 0;
    }
    $starting_price += $fee;

	/*if( isset( $options['no_donation'] ) ) {
		$donation = 0;
	} else {
		$donation = $options['suggested_donation'];
	}*/

	if( isset($options['no_donation']) && $options['no_donation'] == 0){
		$donation = $options['suggested_donation'];
	}else{
		$donation = 0;
	}
    $starting_price += $donation;

    if( isset( $options['charge_tax'] ) && $options['charge_tax'] == 1 ) {
	    if( isset( $options['tax_rate'] ) && (!is_null($options['tax_rate']) ) ) {
		    $tax = round( ( ( $options['tax_rate'] / 100 ) * $starting_price ), 2 );
      } else {
				$tax = 0;
			}
    }else{
			$tax = 0;
		}
	// note to self - this code is also in membership.js
	$member_form .=
	'<input type="hidden" class="paypal cart cmd" name="cmd" value="_cart">
	<input type="hidden" class="paypal cart upload" name="upload" value="1" />
	<input type="hidden" class="paypal cart item_name_1" name="item_name_1" value="' . __( 'Membership', 'cdashmm' ) . '">
	<input type="hidden" class="paypal cart amount_1" name="amount_1" id="amount_1" value="">
	<input type="hidden" class="paypal cart item_name_2" name="item_name_2" value="' . __( 'Donation', 'cdashmm' ) . '">
	<input type="hidden" class="paypal cart amount_2" name="amount_2" id="amount_2" value="' . $donation . '">
	<input type="hidden" class="paypal cart item_name_3" name="item_name_3" value="' . __( 'Processing Fee', 'cdashmm' ) . '">
	<input type="hidden" class="paypal cart amount_3" name="amount_3" id="amount_3" value="' . $fee . '">
	<input type="hidden" class="paypal cart item_name_4" name="item_name_4" value="' . __( 'Tax', 'cdashmm' ) . '">
  <input type="hidden" class="paypal cart amount_4" name="amount_4" id="amount_4" value="' . $tax . '">';
}
add_action( 'cdashmm_paypal_hidden_fields', 'cdashmm_paypal_cart_fields', 10 );

// ------------------------------------------------------------------------
// AJAX functions for membership form
// ------------------------------------------------------------------------
// AJAX - when a membership level is selected, find the price and send it to the form
function cdashmm_update_total_amount() {
    if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce")) {
        exit( "There was an error." );
    }
    $levelid = $_POST['level_id'];
    $cost = cdashmm_get_membership_level_price($levelid);
		$cost_no_commas = str_replace( ',', '', $cost );
    $results = floatval( $cost_no_commas );
    die( $results );
}
add_action( 'wp_ajax_nopriv_cdashmm_update_total_amount', 'cdashmm_update_total_amount' );
add_action( 'wp_ajax_cdashmm_update_total_amount', 'cdashmm_update_total_amount' );

// AJAX - when a business name is entered, check whether the business is already in the database
function cdashmm_find_existing_business() {
    if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce")) {
        exit( "There was an error." );
    }
    $name = $_POST['name'];
    $results = '';
    $args = array(
        'post_type' => 'business',
        'post_title_like' => $name,
        'posts_per_page' => -1,
        'orderby' => 'title',
        'order' => 'ASC',
    );
    $bus_query = new WP_Query( $args );

    // The Loop
    if ( $bus_query->have_posts() ) :
    	$results .= '<div class="alert"><p>' . __( 'It looks like your business is already in our database!  To verify, select your business below:', 'cdashmm' ) . '</p>';
	    while ( $bus_query->have_posts() ) : $bus_query->the_post();
	    	$results .= '<input type="radio" name="business_id" class="business_id" value="' . get_the_id() . '">&nbsp;' . get_the_title() . '<br />';
	    endwhile;
	    $results .= '<input type="radio" name="business_id" class="business_id" value="new">&nbsp;None of the above<br /></div>';
    endif;
    // Reset Post Data
    wp_reset_postdata();
    die($results);
}
add_action( 'wp_ajax_nopriv_cdashmm_find_existing_business', 'cdashmm_find_existing_business' );
add_action( 'wp_ajax_cdashmm_find_existing_business', 'cdashmm_find_existing_business' );

// AJAX - when an existing business is selected, fill in the form
function cdashmm_prefill_membership_form() {
    if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce")) {
        exit( "There was an error." );
    }
    $business_id = $_POST['business_id'];
    if( "new" == $_POST['business_id'] ) {
    	die();
    }
    $results = array();
    $args = array(
        'post_type' => 'business',
        'p' => $business_id,
    );
    $bus_query = new WP_Query( $args );

    // The Loop
    if ( $bus_query->have_posts() ) :
	    while ( $bus_query->have_posts() ) : $bus_query->the_post();
			$results['business_id'] = get_the_id();
			$results['business_name'] = get_the_title();
			global $billing_metabox;

			$billingmeta = $billing_metabox->the_meta();

			if(isset($billingmeta['billing_address']) || isset($billingmeta['billing_city']) || isset($billingmeta['billing_state']) || isset($billingmeta['billing_zip']) || isset($billingmeta['billing_country']) || isset($billingmeta['billing_phone']) || isset($billingmeta['billing_email']) ){
				// the billing address exists, so we'll insert it into the form
				if( isset ( $billingmeta['billing_address'] ) )
					 $results['address'] = $billingmeta['billing_address'];
				if( isset ( $billingmeta['billing_city'] ) )
					$results['city'] = $billingmeta['billing_city'];
				if( isset ( $billingmeta['billing_state'] ) )
					$results['state'] = $billingmeta['billing_state'];
				if( isset ( $billingmeta['billing_zip'] ) )
					$results['zip'] = $billingmeta['billing_zip'];
				if( isset ( $billingmeta['billing_country'] ) )
					$results['country'] = $billingmeta['billing_country'];
				if( isset ( $billingmeta['billing_phone'] ) )
					$results['phone'] = $billingmeta['billing_phone'];
				if( isset ( $billingmeta['billing_email'] ) )
					$results['email'] = $billingmeta['billing_email'];
			} else {
				// the billing address doesn't exist, so let's grab the first address and insert it instead
				global $buscontact_metabox;
				$contactmeta = $buscontact_metabox->the_meta();
				if( isset( $contactmeta['location'] ) ) {
					$locations = $contactmeta['location'];
					if( isset( $location['donotdisplay'] ) && "1" == $location['donotdisplay'] ) {
						continue;
					} else {
						foreach ( $locations as $location ) {
							if( isset( $location['phone'] ) ) {
								$phones = $location['phone'];
								foreach($phones as $phone) {
									$results['phone'] = $phone['phonenumber'];
									break; // we only need one, so we'll stop the loop here
								}
							}
							if( isset( $location['email'] ) ) {
								$emails = $location['email'];
								foreach($emails as $email) {
									$results['email'] = $email['emailaddress'];
									break; // we only need one, so we'll stop the loop here
								}
							}
							if( isset ( $location['address'] ) )
								$results['address'] = $location['address'];
							if( isset ( $location['city'] ) )
								$results['city'] = $location['city'];
							if( isset ( $location['state'] ) )
								$results['state'] = $location['state'];
							if( isset ( $location['zip'] ) )
								$results['zip'] = $location['zip'];
							if( isset ( $location['country'] ) )
								$results['country'] = $location['country'];
							break; // we only need one, so we'll stop the loop here
						}
					}
				}
			}
	    endwhile;
    endif;

    // Reset Post Data
    wp_reset_postdata();
    // $results = json_encode($results);
   	wp_send_json($results);
    die();
}
add_action( 'wp_ajax_nopriv_cdashmm_prefill_membership_form', 'cdashmm_prefill_membership_form' );
add_action( 'wp_ajax_cdashmm_prefill_membership_form', 'cdashmm_prefill_membership_form' );

//Check if username is already registered
function cdashmm_check_username(){
	// check for the nonce and get out of here right away if it isn't right
	if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce")) {
	        exit( "There was an error." );
	}
	$response = array();
	$username = sanitize_text_field($_POST['username']);

	if ( 4 > strlen( $username ) ) {
    	$response['text'] = __('Username too short. At least 4 characters is required', 'cdashmm' );
			$response['error'] = 'ui-state-error';
	}else if(username_exists($username)){
			$response['text'] = __('Sorry, this username is unavailable', 'cdashmm');
			$response['error'] = 'ui-state-error';
	}else if ( ! validate_username( $username ) ) {
			$response['text'] = __( 'Sorry, the username you entered is not valid', 'cdashmm');
			$response['error'] = 'ui-state-error';
	}else{
			$response['text'] = __('The username you chose is available', 'cdashmm');
			$response['error'] = 'ui-state-valid';
	}

	wp_send_json($response);
    die();
}
add_action( 'wp_ajax_nopriv_cdashmm_check_username', 'cdashmm_check_username' );
add_action( 'wp_ajax_cdashmm_check_username', 'cdashmm_check_username' );


//Check if password is more than 5 characters
function cdashmm_check_password(){
	// check for the nonce and get out of here right away if it isn't right
	if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce")) {
	        exit( "There was an error." );
	}
	$response = array();
	$password = sanitize_text_field($_POST['password']);

	if ( 5 > strlen( $password ) ) {
    	$response['text'] = __('Password too short. At least 5 characters is required', 'cdashmm' );
			$response['error'] = 'ui-state-error';
	}else{
		$response['text'] = ' ';
		$response['error'] = 'ui-state-valid';
	}
	wp_send_json($response);
    die();
}
add_action( 'wp_ajax_nopriv_cdashmm_check_password', 'cdashmm_check_password' );
add_action( 'wp_ajax_cdashmm_check_password', 'cdashmm_check_password' );

//Check if email is valid
function cdashmm_check_email($action){
	// check for the nonce and get out of here right away if it isn't right
	if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce")) {
	        exit( "There was an error." );
	}
	$response = array();
	$cdashmm_form_action = $_POST['cdashmm_form_action'];
	$email = ($_POST['email']);
			if ( email_exists( $email ) ) {
				if($cdashmm_form_action == "signup"){
					$response['text'] = __('This email address already exists. Please use another email to sign up.', 'cdashmm' );
					$response['error'] = 'ui-state-error';
				}
			}else	if(!is_email($email)){
				$response['text'] = __('This email is not valid. Please enter a valid email address.', 'cdashmm');
				$response['error'] = 'ui-state-error';
			}else{
				$response['text'] = ' ';
				$response['error'] = 'ui-state-valid';
			}
			wp_send_json($response);
		    die();
}
add_action( 'wp_ajax_nopriv_cdashmm_check_email', 'cdashmm_check_email' );
add_action( 'wp_ajax_cdashmm_check_email', 'cdashmm_check_email' );

// AJAX - save form data before it gets sent off to PayPal

function cdashmm_process_membership_form() {
	// check for the nonce and get out of here right away if it isn't right
    if ( !wp_verify_nonce( $_POST['nonce'], "cdashmm_membership_nonce" ) ) {
        exit( "There was an error." );
    }
 	// gather all of the variables
	if(isset($_POST['business_id'])){
		$business_id = $_POST['business_id'];
	}
    $name = $_POST['name'];
		if(isset($_POST['business_category'])){
			$business_category = $_POST['business_category'];
		}
    $address = $_POST['address'];
    $city = $_POST['city'];
		$state = $_POST['state'];
		$zip = $_POST['zip'];
		$country = $_POST['country'];
		$phone = $_POST['phone'];
		$email = $_POST['email'];
		if(isset($_POST['biz_main_address'])){
			$set_biz_address = true;
		}else{
			$set_biz_address = false;
		}
    $today = date( 'Y-m-d' );
    $total = $_POST['total'];
    $membership_level = $_POST['membership_level'];
    $member_amt = $_POST['member_amt'];
    if( isset( $_POST['donation'] ) ) {
    	$donation = $_POST['donation'];
    }else{
			$donation = 0;
		}
		/*if(isset($_POST['processing'])){
			$processing_fee = $_POST['processing'];
		}*/
		$processing_fee = cdashmm_get_processing_fee();
		if(isset($_POST['tax'])){
			$tax = $_POST['tax'];
		}else{
			$tax = 0;
		}

		if(cdashmm_check_mm_connected_to_wc() ){
			$invoice_id = cdashmm_calculate_invoice_number();
		}else{
			$invoice_id = $_POST['invoice_id'];
		}

		if(isset($_POST['first_name'])){
			$first_name = $_POST['first_name'];
		}else{
			$first_name = '';
		}
		if(isset($_POST['last_name'])){
			$last_name = $_POST['last_name'];
		}else{
			$last_name = '';
		}
		if(isset($_POST['username'])){
			$username = $_POST['username'];
		}else{
			$username = '';
		}
		if(isset($_POST['password'])){
			$password = $_POST['password'];
		}else{
			$password = '';
		}
		if(isset($_POST['referral'])){
			$referral = $_POST['referral'];
		}else{
			$referral = '';
		}
		if(isset($_POST['cdashmc_subscribe_checkbox'])){
			$mailchimp_subscribe = true;
		}else{
			$mailchimp_subscribe = false;
		}
		//$merge_fields = array('FNAME' => $first_name,'LNAME' => $last_name);
		//$mailchimp_subscribe = $_POST['cdashmc_subscribe_checkbox'];

    $options = get_option( 'cdashmm_options' );

	// Create or update the business
    if( isset( $business_id ) && $business_id !== '' ) {
		// we already have a business, so let's update it
		cdashmm_create_update_business($business_id, $address, $city, $state, $zip, $country, $email, $phone, $set_biz_address, $membership_level, $referral, '' );
	} else {
		// we need to create a new business
		$business_details = array(
			'post_status'    	=> 'draft',
			'post_type'      	=> 'business',
			'post_title'		=> $name,
			'post_content'  	=> __( 'This business draft was automatically generated by the membership form.', 'cdashmm' ),
		);
		$business_id = wp_insert_post( $business_details );
		cdashmm_create_update_business($business_id, $address, $city, $state, $zip, $country, $email, $phone, $set_biz_address, $membership_level, $referral, $business_category );

		//Create User
		//If cdashmu is active, call cdashmu_complete_user_registration(fields). This will create the user as business editor, people record and connect everything.
		if(cdash_check_cdashmu_active()) {
			$user_id = cdashmu_complete_user_registration($first_name, $last_name, $username, $password, $email, $name, $business_id, false);
		}else if(cdashmm_check_mm_connected_to_wc() || cdashmm_check_mm_connected_to_wc_payments() || cdashmm_enable_rc()){
			$user_id = cdashmm_user_registration($first_name, $last_name, $username, $password, $email, $business_id, false, 'subscriber', 'Created by Chamber Dashboard Member Manager');
		}

	}
    $business_name = get_the_title( $business_id );

		//Create an invoice
		$invoice = cdashmm_create_and_update_invoice($business_id, $business_name, $invoice_id, $total, $today, $membership_level, $member_amt, $tax, $donation, $processing_fee);

		//If MM is connected to WC, create an order and connect the order to the invoice
		if(cdashmm_check_mm_connected_to_wc()){
				$order_id = cdashmmpro_create_wc_order($first_name, $last_name, $name, $email, $phone, $address, $city, $state, $zip, $country, $membership_level, $total, $invoice, $user_id, $donation, $tax);
		}else{
			$order_id = '';
		}
		//Get the post method
		$method = cdashmm_get_post_method();

		//Set the invoice status cdashmm_set_invoice_status()
		cdashmm_set_invoice_status($method, $invoice);

		// if paying by check, or using WC for payments, send emails to business and to admin
		//cdashmm_emails_to_business_and_admin();
		//if(($method == "check") || ($method == "wc_payments")){ // Deleting this because we do not want any emails to go out when using WC Payments
		if(($method == "check")){
			cdashmm_emails_to_business_and_admin($order_id, $invoice, $email, $business_id, $total);
		}

		//If MailChimp addon is active, subscribe to the selected list
		if($mailchimp_subscribe){
			if(isset($first_name) && isset($last_name)){
					$merge_fields = array('FNAME' => $first_name,'LNAME' => $last_name);
			}else{
				$merge_fields = array('FNAME' => '','LNAME' => '');
			}
			cdashmm_mailchimp_subscribe($email, $merge_fields);

		}

		//Get the results page cdashmm_get_results_page()
		$results = cdashmm_get_results_page($method, $invoice, $order_id);

     die($results);
		//die();
}//End of process memberhsip form
add_action( 'wp_ajax_nopriv_cdashmm_process_membership_form', 'cdashmm_process_membership_form' );
add_action( 'wp_ajax_cdashmm_process_membership_form', 'cdashmm_process_membership_form' );

function cdashmm_create_update_business($business_id, $address, $city, $state, $zip, $country, $email, $phone, $set_biz_address, $membership_level, $referral, $business_category ){
	// add a serialised array for wpalchemy to work - see http://www.2scopedesign.co.uk/wpalchemy-and-front-end-posts/
	$fields = array('_cdash_billing_address', '_cdash_billing_city', '_cdash_billing_state', '_cdash_billing_zip', '_cdash_billing_country', '_cdash_billing_email', '_cdash_billing_phone' );
	$str = $fields;
	update_post_meta( $business_id, 'billing_meta_fields', $str );

	// Create the array of billing information for wpalchemy
	$billingfields = array(
			array(
			'billing_address',
			'billing_city',
			'billing_state',
			'billing_zip',
			'billing_country',
			'billing_phone',
			'billing_email',
			)
		);

	// update each individual field
	update_post_meta( $business_id, '_cdash_billing_address', $address );
	update_post_meta( $business_id, '_cdash_billing_city', $city );
	update_post_meta( $business_id, '_cdash_billing_state', $state );
	update_post_meta( $business_id, '_cdash_billing_zip', $zip );
	update_post_meta( $business_id, '_cdash_billing_country', $country );
	update_post_meta( $business_id, '_cdash_billing_email', $email );
	update_post_meta( $business_id, '_cdash_billing_phone', $phone );

	if($set_biz_address){
		// Get the geolocation data
		if( isset( $address ) ) {
			// ask Google for the latitude and longitude
			$rawaddress = $address;
			if( isset( $city ) ) {
				$rawaddress .= ' ' . $city;
			}
			if( isset( $state ) ) {
				$rawaddress .= ' ' . $state;
			}
			if( isset( $zip ) ) {
				$rawaddress .= ' ' . $zip;
			}
			if(function_exists('cdash_get_google_map_api')){
				$google_map_api_key = cdash_get_google_map_api();
			}
			$map_address = urlencode( $rawaddress );
			$json = wp_remote_get( "https://maps.googleapis.com/maps/api/geocode/json?key='.$google_map_api_key.'&address=" . $map_address );
			$json = json_decode($json['body'], true);
			if( is_array( $json ) && $json['status'] == 'OK') {
				$latitude = $json['results'][0]['geometry']['location']['lat'];
				$longitude = $json['results'][0]['geometry']['location']['lng'];
			}
		}

		//Add the address as the main business address
		$fields = array('_cdash_location');
		$str = $fields;
		update_post_meta( $business_id, 'buscontact_meta_fields', $str );

		// Get the phone number and put it in the array format wpalchemy expects
		$phone_numbers = array();
		$phone_numbers[]['phonenumber'] = $phone;

		// Get the email addresse and put it in the array format wpalchemy expects
		$emails = array();
		$emails[]['emailaddress'] = $email;

		//Create Business location fields array
		$locationfields = array(
				array(
				'altname' 	=>'',
				'address'	=> $address,
				'city'		=> $city,
				'state'		=> $state,
				'zip'			=> $zip,
				'country'   => $country,
				'hours'     => '',
				'latitude'	=> $latitude,
				'longitude'	=> $longitude,
				'url'				=> '',
				'phone'			=> $phone_numbers,
				'email'			=> $emails,
				)
			);

			// Add all of the post meta data in one fell swoop
			add_post_meta( $business_id, '_cdash_location', $locationfields );
	}

		//Add Business referral
		//if($referral){
			$referral_fields = array('_cdash_busreferral');
			$ref_str = $referral_fields;
			update_post_meta($business_id, 'busreferral_meta_fields', $ref_str);
			update_post_meta($business_id, '_cdash_busreferral', $referral);
		//}

	// add membership level
	wp_set_post_terms( $business_id, $membership_level, 'membership_level', false );
	if($business_category != ''){
		// add Business Category
		wp_set_post_terms( $business_id, $business_category, 'business_category', false );
	}

	//If Recurring Payments is active, set the Membership Renewal Date to be 1 year from today
	if(function_exists('cdashrp_requires_wordpress_version')){
			cdashrp_set_mrd($business_id);
	}

	/*if(cdash_check_wc_payments_active()){
		cdashrp_set_mrd($business_id);
	}*/
}

//Create and Update the invoice
function cdashmm_create_and_update_invoice($business_id, $business_name, $invoice_id, $total, $today, $membership_level, $member_amt, $tax, $donation, $processing_fee){
	// Create an invoice for this transaction
	$invoice_details = array(
	'post_status'    	=> 'publish',
	'post_type'      	=> 'invoice',
	'post_title'		=> __( 'Membership for ', 'cdashmm' ) . $business_name,
	'post_content'  	=> __( 'This invoice was automatically generated by the membership form.', 'cdashmm' ),
	);
	$invoice = wp_insert_post( $invoice_details );
	// add a serialised array for wpalchemy to work
	$invoicefields = array(
		'_cdashmm_invoice_number',
		'_cdashmm_amount',
		'_cdashmm_duedate',
		'_cdashmm_item_membershiplevel',
		'_cdashmm_item_membershipamt',
		'_cdashmm_item_tax',
		'_cdashmm_item_donation',
		'_cdashmm_item_processing_fee',
		'_cdashmm_paidamt',
		'_cdashmm_paiddate',
		'_cdashmm_paymethod',
		'_cdashmm_transaction'
		);
	$str = $invoicefields;
	update_post_meta( $invoice, 'invoice_meta_fields', $str );

	// update the individual fields
	update_post_meta( $invoice, '_cdashmm_invoice_number', $invoice_id );
	update_post_meta( $invoice, '_cdashmm_amount', $total );
	update_post_meta( $invoice, '_cdashmm_duedate', $today );
	update_post_meta( $invoice, '_cdashmm_item_membershiplevel', $membership_level );
	update_post_meta( $invoice, '_cdashmm_item_membershipamt', $member_amt );
	update_post_meta( $invoice, '_cdashmm_item_tax', $tax);
	if( isset( $donation ) ) {
		update_post_meta( $invoice, '_cdashmm_item_donation', $donation );
	}
	if(isset($processing_fee)){
		update_post_meta( $invoice, '_cdashmm_item_processing_fee', $processing_fee );
	}
	/*if( isset( $options['use_processing_fee'] ) ) {
		if( isset( $options['processing_fee_amount'] ) ) {
			$processing_fee = $options['processing_fee_amount'];
		} else {
			$processing_fee = 0;
		}
		update_post_meta( $invoice, '_cdashmm_item_processing_fee', $processing_fee );
	}*/
	// connect the invoice to the business
	p2p_type( 'invoices_to_businesses' )->connect( $invoice, $business_id, array(
	    'date' => current_time('mysql')
	) );

	return $invoice;
}//End of create invoice function

//Create WooCommerce order
function cdashmmpro_create_wc_order($first_name, $last_name, $name, $email, $phone, $address, $city, $state, $zip, $country, $membership_level, $total, $invoice, $user_id, $donation, $tax){
	$wc_address = array(
	 'company'    => $name,
	 'email'      => $email,
	 'phone'      => $phone,
	 'address_1'  => $address,
	 'address_2'  => '',
	 'city'       => $city,
	 'state'      => $state,
	 'postcode'   => $zip,
	 'country'    => $country
 );
$options = get_option( 'cdashmm_options' );
if( isset( $options['use_processing_fee'] ) ) {
	if( isset( $options['processing_fee_amount'] ) ) {
		$processing_fee = $options['processing_fee_amount'];
	} else {
		$processing_fee = 0;
	}
}else{
	$processing_fee = 0;
}

$product_id = cdashmm_membership_level_to_product_id($membership_level);
$order_id = cdashmm_create_wc_order($wc_address, $product_id, $total, $user_id, $donation, $tax, $processing_fee);
// connect the invoice to the business
 p2p_type( 'invoices_to_shop_order' )->connect( $invoice, $order_id, array(
		 'date' => current_time('mysql')
 ) );

 return $order_id;
}

//Get the post methods
function cdashmm_get_post_method(){
	if( "paypal" == $_POST['method'] ) {
		$method = "paypal";
	} elseif( "check" == $_POST['method'] ) {
		$method = "check";
	} elseif("wc_payments" == $_POST['method']){
		$method = "wc_payments";
	}
	return $method;
}

//Set the invoice status
function cdashmm_set_invoice_status($method, $invoice){
	if( "paypal" == $method ) {
		// if paying with PayPal, mark invoice status as pending for now
		$pending = get_term_by( 'slug', 'pending', 'invoice_status' );
		wp_set_post_terms( $invoice, $pending->term_id, 'invoice_status', false );
	} elseif( "check" == $method ) {
		// if paying by check, mark invoice status as open
		$open = get_term_by( 'slug', 'open', 'invoice_status' );
		wp_set_post_terms( $invoice, $open->term_id, 'invoice_status', false );
	} elseif("wc_payments" == $method){
		$pending = get_term_by( 'slug', 'pending', 'invoice_status' );
		wp_set_post_terms( $invoice, $pending->term_id, 'invoice_status', false );
	}
}

//Send emails to businesses and admin
function cdashmm_emails_to_business_and_admin($order_id, $invoice, $email, $business_id, $total){
	// send email receipt to business
	$options = get_option( 'cdashmm_options' );
	if($order_id != ''){
		$order = wc_get_order($order_id);
		$pay_now_url = $order->get_checkout_payment_url();
	}
		$receipt_to = $email;
		$receipt_subject = __( 'Invoice from ', 'cdashmm' ) . $options['orgname'];
		$receipt_message = $options['check_message'];

	if( cdashmm_check_mm_connected_to_wc() || cdashmm_check_mm_connected_to_wc_payments() ) {
    	//$receipt_message .= '<p><strong>' . __( 'View the invoice: ', 'cdashmm' ) . '</strong><a href="' . $pay_now_url . '">' . $pay_now_url . '</a></p>';
		} else{//if mm pro is not active
			$receipt_message .= '<p><strong>' . __( 'View the invoice: ', 'cdashmm' ) . '</strong><a href="' . get_the_permalink( $invoice ) . '">' . get_the_permalink( $invoice ) . '</a></p>';
		}
    $receipt_from = "From: " . $options['receipt_from_name'] . " <" . $options['receipt_from_email'] . ">";
    cdashmm_send_email( $receipt_from, $receipt_to, '', $receipt_subject, $receipt_message );
    // send email to site admin
    $admin_to = $options['admin_email'];
		if( cdashmm_check_mm_connected_to_wc() || cdashmm_check_mm_connected_to_wc_payments() ) {
			$admin_subject = __( 'New Payment received!', 'cdashmm' );
			$admin_message = '<p>' . get_the_title( $business_id ) . __( ' has just filled out your membership form.', 'cdashmm' ) . '</p>';
			$admin_message .= '<p><strong>' . __( 'View the order: ', 'cdashmm' ) . '</strong><a href="' . $pay_now_url . '">' . $pay_now_url . '</a></p>';
		}else{
			$admin_subject = __( 'New Payment By Check', 'cdashmm' );
			$admin_message = '<p>' . get_the_title( $business_id ) . __( ' has just filled out your membership form, and will pay by check.', 'cdashmm' ) . '</p>';
			$admin_message .= '<p><strong>' . __( 'View the invoice: ', 'cdashmm' ) . '</strong><a href="' . get_the_permalink( $invoice ) . '">' . get_the_permalink( $invoice ) . '</a></p>';
		}
    $admin_message .= '<p><strong>' . __( 'Payment amount: ', 'cdashmm' ) . '</strong>' . cdashmm_display_price( $total ) . '</p>';
    $admin_message .= '<p><strong>' . __( 'View the business: ', 'cdashmm' ) . '</strong><a href="' . get_the_permalink( $business_id ) . '">' . get_the_permalink( $business_id ) . '</a></p>';
    if( "draft" == get_post_status( $business_id ) ) {
        $admin_message .= '<p>' . get_the_title( $business_id ) . __( 'is a new business, so you need to publish the new business before it will appear in your member directory.', 'cdashmm' ) . '</p>';
				$admin_message .= '<p><a href="' . get_edit_post_link( $business_id ) . '">' . __('Click here to approve the business listing.', 'cdashmm') . '</a></p>';
    }
  	$admin_from = "Chamber Dashboard <" . $options['receipt_from_email'] . ">";
    cdashmm_send_email( $admin_from, $admin_to, '', $admin_subject, $admin_message );
}
//}

//Get the results page
function cdashmm_get_results_page($method, $invoice, $order_id){
	if( "paypal" == $method ) {
		$results = $invoice;
	} elseif( "check" == $method ) {
		$results = get_permalink( $invoice );
	} elseif("wc_payments" == $method){
		$order = wc_get_order($order_id);
		$pay_now_url = $order->get_checkout_payment_url();
		$results = $pay_now_url;
	}	else {
		$results = __( 'No payment method selected', 'cdashmm' );
	}
	return $results;
}

// ------------------------------------------------------------------------
// Single Invoice View
// ------------------------------------------------------------------------

// Enqueue stylesheet for single invoice
function cdashmm_single_invoice_style() {
	if( is_singular( 'invoice' ) ) {
		wp_enqueue_style( 'cdashmm-invoice', plugin_dir_url(__FILE__) . 'css/invoice.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'cdashmm_single_invoice_style' );

// Filter the title so it just says "invoice"
function cdashmm_single_invoice_title( $title ) {
	global $post;
	/*if( is_singular('invoice') && $title == $post->post_title ) {
        $title = "Invoice";
    }*/
	if( is_singular('invoice') && 'invoice' == get_post_type() && $title == $post->post_title ) {
        $title = "Invoice";
    }
    return $title;
}
add_filter( 'the_title', 'cdashmm_single_invoice_title', 10, 2 );

// Add a class to previous and next post list on the single invoice page so that it can be hidden using CSS
function cdashmm_invoice_posts_link_attributes($output) {
	if(is_singular('invoice') || is_single('invoice')){
		$code = 'class="single_invoice_nav_link"';
    	return str_replace('<a href=', '<a '.$code.' href=', $output);
	}
}
add_filter('next_post_link', 'cdashmm_invoice_posts_link_attributes');
add_filter('previous_post_link', 'cdashmm_invoice_posts_link_attributes');

// add script to footer to print invoice div
// http://stackoverflow.com/a/7532581/1112258
function cdashmm_invoice_footer_scripts() {
    if( is_singular( 'invoice' ) ) { ?>
        <script type="text/javascript">
            function printDiv(divName) {
		     var printContents = document.getElementById(divName).innerHTML;
		     var originalContents = document.body.innerHTML;
		     document.body.innerHTML = printContents;
		     window.print();
		     document.body.innerHTML = originalContents;
}
        </script>
<?php }
}
add_action('wp_footer', 'cdashmm_invoice_footer_scripts');

// Display single invoice (filter content)
function cdashmm_single_invoice( $content ) {
	if( is_singular('invoice') ) {
		// get options
		$options = get_option( 'cdashmm_options' );
	    $paypal = true;
	    if( !isset( $options['paypal_email'] ) || '' == $options['paypal_email'] ) {
	    	$paypal = false;
	    }
		// get the business associated with this invoice
		$invoice_id = get_the_id();
        $args = array(
            'post_type' => 'business',
            'connected_type' => 'invoices_to_businesses',
            'connected_items' => $invoice_id,
        );
        $thisbusiness = new WP_Query( $args );
        // $msg = "<pre>" . print_r($thisbusiness, true) . "</pre>";
        // wp_die($msg);
        if ( $thisbusiness->have_posts() ) {
            while ( $thisbusiness->have_posts() ) : $thisbusiness->the_post();
	        		$business_id = get_the_id();
	        		global $billing_metabox;
							$billingmeta = $billing_metabox->the_meta();
							$business_billing = '<p>' . get_post_field( 'post_title', $business_id ) . '<br />'; // this is a convoluted way to get the title, but it bypasses the title filter
							if( isset ( $billingmeta['billing_address'] ) )
								$business_billing .= $billingmeta['billing_address'] . '<br />';
							if( isset ( $billingmeta['billing_city'] ) )
								$business_billing .= $billingmeta['billing_city'] . ', ';
							if( isset ( $billingmeta['billing_state'] ) )
								$business_billing .= $billingmeta['billing_state'] . ' ';
							if( isset ( $billingmeta['billing_zip'] ) )
								$business_billing .= $billingmeta['billing_zip'] . '<br />';
							if( isset ( $billingmeta['billing_countryp'] ) )
								$business_billing .= $billingmeta['billing_country'] . '<br />';
							if( isset ( $billingmeta['billing_phone'] ) )
								$business_billing .= $billingmeta['billing_phone'] . '<br />';
							if( isset ( $billingmeta['billing_email'] ) )
								$business_billing .= $billingmeta['billing_email'];
							$business_billing .= '</p>';
            endwhile;
        } else {
        	$error = __('This invoice does not have a business associated with it.  You need to edit the invoice and add a business.', 'cdashmm' );
        	wp_die( $error );
        }
        wp_reset_postdata();

		// get invoice meta
        global $invoice_metabox;
        $invoice_meta = $invoice_metabox->the_meta();
        $statuses = get_the_terms( get_the_id(), 'invoice_status' );
        $this_status = '';
        if( isset( $statuses ) && !is_wp_error( $statuses ) && $statuses != '' ) {
        	foreach( $statuses as $status ) {
        		$this_status = $status->name;
        	}
        }
        if( isset( $invoice_meta['duedate'] ) ) {
        	$duedate = $invoice_meta['duedate'];
        } else {
        	$duedate = __( 'Invoice due on receipt', 'cdashmm' );
        }
        $cdash_options = get_option( 'cdash_directory_options' );
    	$currency = $cdash_options['currency'];
		$invoice_content =
		'<div id="invoice" class="' . $this_status . '">
			<p><input type="button" onclick="printDiv(\'print-invoice\')" value="' . __( 'Print Invoice', 'cdashmm' ) . '" /></p>
			<div id="print-invoice">
				<div class="invoice-header">
					<div class="invoice-header-contact">
						<div class="invoice-from">
							<h4>From: </h4>
							' . do_shortcode( wpautop( $options['invoice_from'] ) ) . '
						</div>
						<div class="invoice-to">
							<h4>To: </h4>
							' . $business_billing . '
						</div>
					</div>
					<div class="invoice-header-details">
						<ul>
							<li><strong>' . __( 'Invoice #: ', 'cdashmm' ) . '</strong><span class="invoice-number"> ' . $invoice_meta['invoice_number'] . '</span></li>
							<li><strong>' . __( 'Issue Date: ', 'cdashmm' ) . '</strong><span class="issue-date"> ' . get_the_time( 'Y-m-d' ) . '</span></li>
							<li><strong>' . __( 'Due Date: ', 'cdashmm' ) . '</strong><span class="due-date"> ' . $duedate . '</span></li>
							<li><strong>' . __( 'Status: ', 'cdashmm' ) . '</strong><span class="status"> ' . $this_status . '</span></li>';
							if( "Paid" == $this_status && isset( $invoice_meta['paiddate'] ) ) {
								$invoice_content .= '<li><strong>' . __( 'Paid Date: ', 'cdashmm' ) . '</strong><span class="status"> ' . $invoice_meta['paiddate'] . '</span></li>';
							}
						$invoice_content .= '</ul>
					</div>
				</div>
				<div class="invoice-description">'
					. $content .
				'</div>
				<table class="invoice-details">
					<tr>
						<th>Item</th>
						<th>Amount</th>
					</tr>';
					if( isset( $invoice_meta['item_membershiplevel'] ) && isset( $invoice_meta['item_membershipamt'] ) ) {
						$level = get_term_by( 'id', $invoice_meta['item_membershiplevel'], 'membership_level' );
						$invoice_content .=
						'<tr>
							<td>' . __( 'Membership: ', 'cdashmm' ) . $level->name . '</td>
							<td>' . cdashmm_display_price( $invoice_meta['item_membershipamt'] ) . '</td>
						</tr>';
					}
					if( isset( $invoice_meta['items'] ) ) {
						$items = $invoice_meta['items'];
						foreach( $items as $item ) {
							$invoice_content .=
							'<tr>
								<td>' . $item['item_name'] . '</td>
								<td>' . cdashmm_display_price( $item['item_amount'] ) . '</td>
							</tr>';
						}
					}
          if( isset( $invoice_meta['item_tax'] ) && '' !== $invoice_meta['item_tax'] ) {
						$invoice_content .=
						'<tr>
							<td>' . __( 'Tax', 'cdashmm' ) . '</td>
							<td>' . cdashmm_display_price( $invoice_meta['item_tax'] ) . '</td>
						</tr>';
					}
					if( isset( $invoice_meta['item_donation'] ) && '' !== $invoice_meta['item_donation'] ) {
						$invoice_content .=
						'<tr>
							<td>' . __( 'Donation', 'cdashmm' ) . '</td>
							<td>' . cdashmm_display_price( $invoice_meta['item_donation'] ) . '</td>
						</tr>';
					}
					if( isset( $invoice_meta['item_processing_fee'] ) && '' !== $invoice_meta['item_processing_fee'] ) {
						$invoice_content .=
						'<tr>
							<td>' . __( 'Processing Fee', 'cdashmm' ) . '</td>
							<td>' . cdashmm_display_price( $invoice_meta['item_processing_fee'] ) . '</td>
						</tr>';
					}
					$invoice_content .=
					'<tr class="total">
						<td><strong>' . __( 'Total', 'cdashmm') . '</strong></td>
						<td><strong>' . cdashmm_display_price( $invoice_meta['amount'] ) . '</strong></td>
					</tr>
				</table>

				<div class="invoice-footer">
					' . do_shortcode( wpautop( $options['invoice_footer'] ) ) . '
				</div>
			</div><!-- #print-invoice -->';

			// the invoice hasn't been paid, so we'll include a payment button
			if( 'Paid' !== $this_status && true == $paypal ) {
				$invoice_content .=
				'<div class="payment-form">';
				//<form id="invoice_form" action="https://ipnpb.paypal.com/cgi-bin/webscr" method="post">
					$invoice_content .= '<form id="invoice_form" action="https://www.paypal.com/cgi-bin/webscr" method="post">
						<input type="hidden" name="cmd" value="_cart">
						<input type="hidden" name="upload" value="1" />
						<input type="hidden" name="business" value="' . $options['paypal_email'] . '">
						<input type="hidden" name="return" value="' . get_the_permalink() . '">
						<input type="hidden" name="currency_code" value="' . $currency . '">';
						// membership amount, if needed
						$i = 1;
						if( isset( $invoice_meta['item_membershipamt'] ) ) {
							$invoice_content .=
							'<input type="hidden" name="item_name_'.$i.'" value="Membership">
							<input type="hidden" name="amount_'.$i.'" id="amount_'.$i.'" value="' . $invoice_meta['item_membershipamt'] . '">';
							$i++;
						}
						// other items, if needed
						if( isset( $invoice_meta['items'] ) ) {
							$items = $invoice_meta['items'];
							foreach( $items as $item ) {
								$invoice_content .=
								'<input type="hidden" class="paypal cart item_name_'.$i.'" name="item_name_'.$i.'" value="'.$item['item_name'].'">
								<input type="hidden" class="paypal cart amount_'.$i.'" name="amount_'.$i.'" id="amount_'.$i.'" value="' . $item['item_amount'] . '">';
								$i++;
							}
						}
						// donation amount, if needed
						if( isset( $invoice_meta['item_donation']) ) {
							$invoice_content .=
							'<input type="hidden" class="paypal cart item_name_'.$i.'" name="item_name_'.$i.'" value="Donation">
							<input type="hidden" class="paypal cart amount_'.$i.'" name="amount_'.$i.'" id="amount_'.$i.'" value="' . ($invoice_meta['item_donation']) . '">';
                            $i++;
						}

            // tax amount, if needed
						if( isset( $invoice_meta['item_tax']) ) {
							$invoice_content .=
							'<input type="hidden" class="paypal cart item_name_'.$i.'" name="item_name_'.$i.'" value="Tax">
							<input type="hidden" class="paypal cart amount_'.$i.'" name="amount_'.$i.'" id="amount_'.$i.'" value="' . $invoice_meta['item_tax'] . '">';
                            $i++;
						}

                        // Processing Fee amount, if needed
						if( isset( $invoice_meta['item_processing_fee']) ) {
							$invoice_content .=
							'<input type="hidden" class="paypal cart item_name_'.$i.'" name="item_name_'.$i.'" value="Processing Fee">
							<input type="hidden" class="paypal cart amount_'.$i.'" name="amount_'.$i.'" id="amount_'.$i.'" value="' . $invoice_meta['item_processing_fee'] . '">';
              $i++;
						}
            //$invoice_content .= '<p><input type="submit" value="' . __( 'Pay Now With PayPal', 'cdashmm' ) . '"></p>';

						$invoice_content .=
						'<input type="hidden" name="rm" value="2">
						<input type="hidden" name="custom" id="invoice_id" value="' . $invoice_meta['invoice_number'] . '">
						<input type="hidden" name="cbt" value="Return to ' . $options['orgname'] . '">
						<input type="hidden" name="notify_url" value="' . home_url() . '/?cdash-member-manager=paypal-ipn">
						<p><input type="submit" value="' . __( 'Pay Now With PayPal', 'cdashmm' ) . '"></p>
					</form>
				</div>';
			}
		$invoice_content .=
		'<p><input type="button" onclick="printDiv(\'print-invoice\')" value="' . __( 'Print Invoice', 'cdashmm' ) . '" /></p>
		</div>';
		$content = $invoice_content;
	}
	return $content;
}
add_filter('the_content', 'cdashmm_single_invoice');

function cdashmm_hide_lapsed_members_search_filter( $query ) {
	$member_options = get_option('cdashmm_options');
	if(isset($member_options['hide_lapsed_members']) && '1' == $member_options['hide_lapsed_members'] ) {
		if ( !is_admin() && $query->is_main_query() ) {
			$query->set('tax_query', array(
				array(
					'taxonomy' => 'membership_status',
					'field' => 'slug',
					'terms' => array('lapsed'),
					'operator' => 'NOT IN'
				)
			));
  		}
	}
}

add_action('pre_get_posts', 'cdashmm_hide_lapsed_members_search_filter');

function cdashmm_get_processing_fee(){
	$options = get_option( 'cdashmm_options' );
	if(isset($options['use_processing_fee']) ){
			if(isset($options['processing_fee_amount']) ){
					$processing_fee = $options['processing_fee_amount'];
			}
			else{
					$processing_fee = 0;
			}
	}
	else{
			$processing_fee = 0;
	}
	return $processing_fee;
}

function cdashmm_get_tax($member_amt){
	$options = get_option( 'cdashmm_options' );
	if( isset( $options['charge_tax'] ) ) {
		if( isset( $options['tax_rate'] ) && (!is_null($options['tax_rate']) ) ) {
			$tax = round( ( ( $options['tax_rate'] / 100 ) * $member_amt ), 2 );
		} else {
			$tax = 0;
		}
	}else{
		$tax = 0;
	}
	return $tax;
}

function cdashmm_get_donation_amount(){
	$options = get_option( 'cdashmm_options' );
	if( isset( $options['no_donation'] ) ) {
		$donation = 0;
	} else {
		$donation = $options['suggested_donation'];
	}
	return $donation;
}

function cdashmm_mailchimp_subscribe($email, $merge_fields){
		//if(cdashmm_check_mailchimp_addon()){
			$cdashmc_options = get_option('cdash_addon_options');
		//}
			$list_id = $cdashmc_options['cdashmc_list'];
			$api_key = $cdashmc_options['cdash_mailchimp_api_key'];
			$status = 'subscribed'; // "subscribed" or "unsubscribed" or "cleaned" or "pending"
			$email = $email;
			$merge_fields = $merge_fields;
				cdashmc_add_mailchimp_subscriber( $email, $status, $list_id, $api_key, $merge_fields );

}
?>
